/*
 * simple stat routines
 *          by k-chinen@is.aist-nara.ac.jp, 1999
 *
 * $Id$
 */


#ifndef SIM_REC_NAMELEN
#define SIM_REC_NAMELEN     (64)
#endif


typedef struct {
    pthread_mutex_t busy;
    char name[SIM_REC_NAMELEN];
    int  vunit;
    long nslot;
    long count;
    long *hcount;
    long igcount;
    long vsum;
} sim_stat_rec;

int sim_stat_clear(sim_stat_rec *srec);
int sim_stat_alloc_new(sim_stat_rec *addr, char *name, int sz, long *ar);
sim_stat_rec* sim_stat_new(char *name, int sz);
int sim_stat_U_alloc_new(sim_stat_rec *addr, char *name, int un, int sz, long *ar);
sim_stat_rec* sim_stat_U_new(char *name, int un, int sz);

int sim_stat_show(sim_stat_rec *rec, FILE *fp);
int sim_stat_show_lock(sim_stat_rec *rec, FILE *fp);
int sim_stat_showX_lock(sim_stat_rec *rec, FILE *fp);
int sim_stat_show995_lock(sim_stat_rec *rec, FILE *fp);
int sim_stat_show99_lock(sim_stat_rec *rec, FILE *fp);
int sim_stat_show95_lock(sim_stat_rec *rec, FILE *fp);
int sim_stat_show90_lock(sim_stat_rec *rec, FILE *fp);
int sim_stat_show_lock_fd(sim_stat_rec *rec, int ofd);
int sim_stat_show_HTML_nolock_fd(sim_stat_rec *rec, int ofd);
int sim_stat_show_skip_lock_fd(sim_stat_rec *rec, int ofd, int sk);
int sim_stat_show_short(sim_stat_rec *rec, FILE *fp);

int sim_stat_reset(sim_stat_rec *rec);
int sim_stat_add_value(sim_stat_rec *rec, long cv);
double sim_stat_get_ave(sim_stat_rec *rec);


